include HashExample.Inc

.code
start:

	invoke GetModuleHandle,NULL
	mov hInstance,eax
	invoke GetCommandLine
	mov CommandLine,eax
	invoke InitCommonControlsEx,addr IccEx
	invoke DialogBoxParam,hInstance,IDD_DLG_HASH,NULL,addr DlgProc,NULL
	invoke ExitProcess,eax

DlgProc proc hDlg:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	
	.if uMsg==WM_INITDIALOG
		invoke LoadIcon,hInstance,1
		invoke SendMessage,hDlg,WM_SETICON,ICON_SMALL,eax
		invoke GetDlgItem,hDlg,IDC_EDT_INPUT
		invoke SetFocus,eax
	.elseif uMsg==WM_CLOSE
		invoke EndDialog,hDlg,NULL
	.elseif uMsg==WM_COMMAND
		mov eax,wParam
		.if lParam!=0
			mov edx,wParam
			shr edx,16
			.if dx==BN_CLICKED
				.if ax==IDC_BTN_CREATE
					invoke CreateHash,hDlg
				.elseif ax==IDC_BTN_EXIT
					invoke EndDialog,hDlg,NULL
				.endif
			.endif
		.endif
	.else
		mov eax,FALSE
		ret
	.endif
	mov eax,TRUE
	ret

DlgProc endp

CreateHash proc hDlg:HWND

LOCAL hLib			:DWORD
LOCAL dwFuncAddress :DWORD
LOCAL szInput[256]	:BYTE
LOCAL szOutput[256]	:BYTE

	invoke LoadLibrary,addr LibName
	.if eax==NULL
		invoke MessageBox,NULL,addr DllNotFound,addr AppName,MB_OK
	.else
		mov hLib,eax
		invoke GetProcAddress,hLib,addr FunctionName
		.if eax==NULL
			invoke MessageBox,NULL,addr FunctionNotFound,addr AppName,MB_OK
		.else
			mov dwFuncAddress,eax
			invoke GetDlgItemText,hDlg,IDC_EDT_INPUT,addr szInput,MAX_SIZE
			lea ebx,szOutput
			lea edx,szInput
			push ebx
			push edx
			call [dwFuncAddress]
			.if eax!=0
				invoke SetDlgItemText,hDlg,IDC_EDT_OUTPUT,addr szOutput
			.else
				invoke MessageBox,NULL,addr CreationFailed,addr AppName,MB_OK
			.endif			
		.endif
	.endif
;	invoke GetDlgItemText,hDlg,IDC_EDT_INPUT,addr szInput,MAX_SIZE
;	invoke GetHashString,addr szInput,addr szOutput
;	.if eax!=0
;		invoke SetDlgItemText,hDlg,IDC_EDT_OUTPUT,addr szOutput
;	.else
;		invoke MessageBox,NULL,addr CreationFailed,addr AppName,MB_OK
;	.endif			
	ret

CreateHash endp
end start